#include "stdafx.h"

using namespace std;

#include <stdlib.h>

extern unsigned int debug;

void readParams(char* file, Parameters *params,int argc, char* argv[])
{
	ifstream in(file);
	unsigned int index=0;

	string tmp;
	in >> tmp;
	while(!in.eof()){
		if(tmp[0]=='#'){//a comment
			in.ignore(10000, '\n');//ignore the rest of the line
		}else if(tmp=="debug"){
			in >> debug;
		}else if(tmp=="single_stuck_at"){
			in >> params->single_stuck_at;
		}else if(tmp=="number_of_ssa"){
			in >> params->number_of_ssa;
		}else if(tmp=="noise"){
			in >> params->noise;
		}else if(tmp=="fitness_method"){
			in >> params->fitness_method;
		}else if(tmp=="output_protect"){
			in >> params->output_protect;
		}else if(tmp=="fail_type"){
			in >> params->fail_type;
		}else if(tmp=="failrate"){
			in >> params->failrate;
		}else if(tmp=="minfail"){
			in >> params->minfail;
		}else if(tmp=="maxfail"){
			in >> params->maxfail;
		}else if(tmp=="error_tests"){
			in >> params->error_tests;
		}else if(tmp=="error_runs"){
			in >> params->error_runs;
		}else if(tmp=="rel_out_fail"){
			in >> params->rel_out_fail;
		}else if(tmp=="rel_in_fail"){
			in >> params->rel_in_fail;
		}else if(tmp=="rel_both_fail"){
			in >> params->rel_both_fail;
		}else if(tmp=="rel_ina_fail"){
			in >> params->rel_ina_fail;
		}else if(tmp=="rel_inb_fail"){
			in >> params->rel_inb_fail;
		}else if(tmp=="rel_in_both_fail"){
			in >> params->rel_in_both_fail;
		}else if(tmp=="gates"){
			in >> params->gateCount;
		}else if(tmp=="generations"){
			in >> params->generations;
		}else if(tmp=="individuals"){
			in >> params->individuals;
		}else if(tmp=="report_gap"){
			in >> params->reportGap;
		}else if(tmp=="algorithm"){
			in >> params->algorithm;
		}else if(tmp=="testrun"){
			in >> params->testrun;
		}else if(tmp=="ga_groupsize"){
			in >> params->ga_groupsize;
		}else if(tmp=="ga_elitism"){
			in >> params->ga_elitism;
		}else if(tmp=="ga_selectionprobability"){
			in >> params->ga_selectionprobability;
		}else if(tmp=="ga_crossoverrate"){
			in >> params->ga_crossoverrate;
		}else if(tmp=="ga_mutationrate"){
			in >> params->ga_mutationrate;
		}else if(tmp=="size_factor"){
			in >> params->sizeFactor;
		}else if(tmp=="fitness_limit"){
			in >> params->fitnessLimit;
		}else if(tmp=="bias"){
			in >> params->bias;
		}else if(tmp=="seed"){
			in >> params->seed;
		}else if(tmp=="count_vcc_gnd"){
			in >> params->count_vcc_gnd;
		}else if(tmp=="individual"){
			params->individual=new Individual();
			in >> *params->individual;
      cout << "\nUsing specified individual\n";
		}else if(tmp=="generation"){
      params->preloadgeneration=1;
      cout << "IMPLEMENTATION OF GENERATION TESTING NOT COMPLETE !!\n";exit(1);
      cout << "\n\nREAD\n\n";
      params->generation=new Generation(params); // m�sjekkes om ok
      cout << "\n\nDONE\n\n";      
      params->preloadgeneration=0;
			in >> *params->generation;
		}else if(tmp=="circuit_type"){
			in >> params->circuit_type;
		}else if(tmp=="inputs"){
			in >> params->inputCount;
		}else if(tmp=="outputs"){
			in >> params->outputCount;
		}else if(tmp=="data_count"){
			in >> params->dataCount;
			//TODO: test if they exist!
			params->inputs=new float*[params->dataCount];
			params->outputs=new float*[params->dataCount];
			index=0;
		}else if(tmp=="data"){
			if(params->inputs==0 || params->outputs==0 || params->dataCount==0){
				cerr << "Error while parsing paramfile: data param with inputs, outputs or data_count not set or set to zero!\n";
				exit(1);
			}
			if(index>=params->dataCount){
				cerr << "Error while parsing paramfile: Found more data params than specified!\n";
				exit(1);
			}

			params->inputs[index]=new float[params->inputCount];
			params->outputs[index]=new float[params->outputCount];

			in >> tmp;
			if(tmp.length()!=params->inputCount){
				cerr << "Error while parsing paramfile: data param nr " << index << " has the wrong number of input values!\n";
				exit(1);
			}
			unsigned int a;
			for(a=0;a<params->inputCount;++a)
				params->inputs[index][a]=(tmp[a]=='1'?1:0);

			in >> tmp;
			if(tmp.length()!=params->outputCount){
				cerr << "Error while parsing paramfile: data param nr " << index << " has the wrong number of output values!\n";
				exit(1);
			}
			for(a=0;a<params->outputCount;++a)
				params->outputs[index][a]=(tmp[a]=='1'?1:0);
			++index;
		}else{
			cerr << "Error while parsing paramfile: unknown param '" << tmp << "'!\n";
			in.ignore(10000, '\n');//ignore the rest of the line
		}
		in >> tmp;
	}

	cout << endl;

	for (int arg=2;arg<argc;arg++) {
		switch (*argv[arg]) {
			case 'f': params->failrate=atof(argv[arg]+2); cout << "cmdline override, failrate: "<< params->failrate << endl; break;
			case 'n': params->noise=atof(argv[arg]+2); cout << "cmdline override, noise:    "<< params->noise << endl; break;
			case 't': params->testrun=1; cout << "cmdline override, testrun:  "<< params->testrun << endl; break;
			case 'e': params->testrun=0; cout << "cmdline override, testrun:  "<< params->testrun << endl; break;
			case 'd': debug=atoi(argv[arg]+2); cout    << "cmdline override, debug:    "<< debug << endl; break;
      case 's': params->seed=abs(atol(argv[arg]+2)); cout << "cmdline override, seed:    "<< params->noise << endl; break;
		}
	}
	
	cout << endl;
	
	
	if (params->testrun == 0) {
		cout << "gate_count:          " << params->gateCount << endl;
		cout << "generations:         " << params->generations << endl;
		cout << "individuals:         " << params->individuals << endl;
		cout << "report_gap:          " << params->reportGap << endl;
		cout << "groupsize:           " << params->ga_groupsize << endl;
		cout << "elitism:             " << params->ga_elitism << endl;
		cout << "sel.prob:	      " << params->ga_selectionprobability << endl;
		cout << "crossoverrate:       " << params->ga_crossoverrate << endl;
		cout << "mutationrate:        " << params->ga_mutationrate << endl;
		cout << "size_factor:         " << params->sizeFactor << endl;
		cout << "fitness_limit:       " << params->fitnessLimit << endl;
		cout << "algorithm:           " << params->algorithm << endl;
		cout << "bias:                " << params->bias << endl;
		cout << "seed:                " << params->seed << endl;
		cout << "inputs:              " << params->inputCount << endl;
		cout << "outputs:             " << params->outputCount << endl;
		cout << "data:                " << params->dataCount << " specified, " << index << " found\n";
		cout << "circuit_type:        " << params->circuit_type << endl;
		cout << "fail_type:           " << params->fail_type << endl;
		cout << "fitness_method:      " << params->fitness_method << endl;
		cout << "output_protect:      " << params->output_protect << endl << endl;
		cout << "single stuck at run: " << params->single_stuck_at << endl;
		cout << "failrate:            " << params->failrate << endl;
		cout << "noise:               " << params->noise << endl;
		cout << "error_tests:         " << params->error_tests << endl;
		cout << "error_runs:          " << params->error_runs << endl;
		
		cout << "\nThis is an evolutionary run!\n";
	}

	else if (params->testrun == 1) {
		cout << "t_seed:              " << params->seed << endl;
		cout << "t_inputs:            " << params->inputCount << endl;
		cout << "t_outputs:           " << params->outputCount << endl;
		cout << "t_data:              " << params->dataCount << " specified, " << index << " found\n";
		cout << "t_circuit_type:      " << params->circuit_type << endl << endl;
		cout << "t_fail_type:         " << params->fail_type << endl;
		cout << "t_fitness_method:    " << params->fitness_method << endl;
		cout << "t_output_protect:    " << params->output_protect << endl << endl;
		cout << "single stuck at run: " << params->single_stuck_at << endl;
		cout << "t_failrate:          " << params->failrate << endl;
		cout << "t_noise:             " << params->noise << endl;
		cout << "t_error_tests:       " << params->error_tests << endl;
		cout << "t_error_runs:        " << params->error_runs << endl;

		cout << "\nThis is a testing run!\n";
	}
	else
		FAULT_END("Invalid value for testrun");
	cout << endl;
}


void report(unsigned long generation, Generation *g){
	cout << "Generation: " << generation << endl
		<< " Best fitness: " << (float)g->getMostFit()->getFitness() << endl;
	if (debug & DBG_POPULATION)
		cout << "GENERATION DUMP:" << endl << "------------------------" << endl << *g << endl;

}


int main(int argc, char* argv[])
{

	if(argc<2){
		cout << "Usage: " << argv[0] << " paramfile [overrides]\n\n";
		cout << "Valid overrides\n";
		cout << "Failrate:   f=(float)\n";
		cout << "Noise:      n=(float)\n";
		cout << "Seed:       s=(long int)\n";
		cout << "Evolution:  e\n";
		cout << "Testrun:    t\n";
		cout << "Debuglevel: d=(uint) [warning: lots of output data]\n\n";
		cout << "E.g. '" << argv[0] << " ehw.txt f=0.1 n=0.3 e d=1'\n";

		return 1;
	}

	time_t startTime=time(NULL);								// starte tidtakning
	Parameters params;											// opprette parameter-objekt
	readParams(argv[1], &params, argc, argv);								// les inn parametere fra fil (argv[1])
	srand(params.seed);											// seed til randomgenerator

	if (params.testrun==1) {									// if this is only a testrun (not evolution)

		// TESTING RUN
		params.individuals = 1;
		Generation *g=new Generation(&params);						// generer generasjon 0

		if(params.individual)										// les inn individ
			g->evaluate(&params);
		else
			FAULT_END("CANNOT TEST WITHOUT INDIVIDUAL");

		cout << "Testing complete (used: " << time(NULL)-startTime << " seconds)\n\n" << endl; // rapporter tidsforbruk

		cout << "t_best_individual:\t" << *g->getMostFit() << endl;								// skriv ut beste individ
		cout << "t_best_fitness:\t" << (float)g->getMostFit()->getFitness() << endl;
    cout << "t_reliability:\t" << (float)g->getMostFit()->getReliability() << endl;
		cout << "t_used_gates:\t" << (unsigned int)g->getMostFit()->getUsedCount() << endl;
	
		delete g;

	} else {  

		// EVOLUTIONARY RUN

		Generation *g=new Generation(&params);						// generer generasjon 0

		if((!params.individual)&&(!params.generation)){										// dersom individ ikke gitt, initialiser
      g->randomize();
			g->evaluate(&params);
		}


		unsigned long generation=0;

		for(generation=0;generation<params.generations;++generation){	// evolusjonsloop

      if(g->getMostFit()->getFitness()>=params.fitnessLimit)		// stopp dersom beste fitness oppn�d
        break;

      //cout << *g; //midlertidig debug shortcut

      //ofstream out("tmp.txt");
      //out << *g;

      //ifstream in("tmp.txt");
      //in >> *g;

      //cout << *g;
      //break;
      
			if (params.reportGap==0)
				report(generation, g);
			else if ((generation%params.reportGap)==0)					// rapporter til skjerm
				report(generation, g);

			Generation* tmp=new Generation(g, &params);					// lag neste generasjon og slett den gamle
			delete g;
			g=tmp;

			g->evaluate(&params);										// evaluer ny generasjon
		}

		
		
		report(generation, g);											// rapporter siste generasjon til skjerm

		cout << "Evolution complete (used: " << time(NULL)-startTime << " seconds)\n\n" << endl; // rapporter tidsforbruk

		cout << "best_individual:\t" << *g->getMostFit() << endl;								// skriv ut beste individ
		cout << "best_fitness:\t" << (float)g->getMostFit()->getFitness() << endl;
		cout << "reliability:\t" << (float)g->getMostFit()->getReliability() << endl;
		cout << "total_gens:\t"<< generation << endl;
		cout << "used_gates:\t" << (unsigned int)g->getMostFit()->getUsedCount() << endl;
		
		delete g;
	}
	

	return 0;
}
