class Individual{
	friend std::ostream& operator<<(std::ostream&, const Individual&);
	friend std::istream& operator>>(std::istream &, Individual&);

 public:
	float fitness;			// fitness of this individual
	float reliability;		// realiability of individual (% successful tests)
	unsigned int usedCount;		// how many of its gate are in use

protected:
	FU* blocks;			// Pointer to the FUs
	unsigned int unitCount;		// Number of FUs

public:
	Individual();
	~Individual();

	void operator=(const Individual&);

	void init(unsigned int units, int inCount);		// Init with num of FUs and inCount
	unsigned int size() const { return unitCount; }		// Get number of FUs
	void randomize();					// Randomize entire individual

	FU& operator[](unsigned int i){ return blocks[i]; }		// Index operator
	const FU& operator[](unsigned int i) const { return blocks[i]; }

	float getFitness() const { return fitness; }			// Gets fitness

 	float getReliability() const { return reliability; }		// Gets fitness

	float getUsedCount() const { return usedCount; }		// Gets usedcount

	void evaluate(Parameters*, float*, bool*, int*, bool*, bool*, int);	// Evaluates entire individual (circuit)

	void mutate(float mutationrate);				// Perform mutations with prob. mutationrate

	void cross(const Individual& mate, unsigned int crosspoint);	// Perform crossover

};
