class Generation{
	friend std::ostream& operator<<(std::ostream&, const Generation&);
	friend std::istream& operator>>(std::istream &, Generation&);

private:
	unsigned int iCount;													// number of individuals
	Individual* individuals;												// pointer to individuals
	int mostFit;															// index of most fit individual

public:
	enum GA{ MUTATE_FITTEST_1=1, MUTATE_FITTEST_2, KILL_HALF, KOOZA, TOURNAMENT };		// type of EA

	Generation(Parameters*);												// constructor
	Generation(const Generation *, Parameters*);							// constructor with predefined data
	virtual ~Generation();

	int size() const{ return iCount; }										// get number of individuals

	Individual& operator[](unsigned int i){ return individuals[i]; }		// define index operator
	const Individual& operator[](unsigned int i) const { return individuals[i]; }

	void randomize();														// randomize all individuals
	void evaluate(Parameters*);												// evaluate all individuals
	Individual* getMostFit();												// get pointer to most fit individual
	const Individual* getMostFit() const;
	int Generation::getMostFitNumber();

};
