
#include <fstream>
#include <string>
#include <memory>
#include <iostream>

#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <search.h>
#include <math.h>
#include <unistd.h>

using namespace std;

float noise, fail, fitness, reliability, t_fitness, t_reliability, t_noise, t_fail, crossoverrate, mutationrate, algorithm, selprob;
unsigned int used, t_used, groupsize, gate_count, individuals, elitism, fitness_method, fail_type, output_protect, t_fitness_method, t_fail_type, t_output_protect, report_gap;
unsigned long totgen, maxgen, seed, t_seed,error_runs,error_tests,t_error_runs,t_error_tests;
unsigned int mode = 0;
unsigned int i = 0;
string batch, type, individual, id;

void readFile(char* file)
{
	ifstream in(file);

	string tmp;
	in >> tmp;
	while(!in.eof()){
		if(tmp[0]=='#'){//a comment
			in.ignore(10000, '\n');//ignore the rest of the line
		}else if(tmp=="failrate:"){
			in >> fail;
		}else if(tmp=="best_fitness:"){
			in >> fitness;
		}else if(tmp=="reliability:"){
			in >> reliability;
		}else if(tmp=="fitness_method:"){
			in >> fitness_method;
		}else if(tmp=="fail_type:"){
			in >> fail_type;      
		}else if(tmp=="output_protect:"){
			in >> output_protect;
		}else if(tmp=="noise:"){
			in >> noise;
		}else if(tmp=="used_gates:"){
			in >> used;
		}else if(tmp=="groupsize:"){
			in >> groupsize;
		}else if(tmp=="elitism:"){
			in >> elitism;
		}else if(tmp=="error_runs:"){
			in >> error_runs;
		}else if(tmp=="error_tests:"){
			in >> error_tests;
		}else if(tmp=="t_error_tests:"){
			in >> t_error_tests;
		}else if(tmp=="t_error_runs:"){
			in >> t_error_runs;
		}else if(tmp=="individuals:"){
			in >> individuals;
		}else if(tmp=="crossoverrate:"){
			in >> crossoverrate;
		}else if(tmp=="mutationrate:"){
			in >> mutationrate;
		}else if(tmp=="algorithm:"){
			in >> algorithm;
		}else if(tmp=="sel.prob:"){
			in >> selprob;
		}else if(tmp=="gate_count:"){
			in >> gate_count;
		}else if(tmp=="seed:"){
			in >> seed;
		}else if(tmp=="t_seed:"){
			in >> t_seed;
		}else if(tmp=="t_noise:"){
			in >> t_noise;
		}else if(tmp=="t_failrate:"){
			in >> t_fail;
		}else if(tmp=="t_used_gates:"){
			in >> t_used;
		}else if(tmp=="generations:"){
			in >> maxgen;
		}else if(tmp=="total_gens:"){
			in >> totgen;
		}else if(tmp=="circuit_type:"){
			in >> type;
		}else if(tmp=="t_best_fitness:"){
			in >> t_fitness;
		}else if(tmp=="t_reliability:"){
			in >> t_reliability;
		}else if(tmp=="t_fitness_method:"){
			in >> fitness_method;
		}else if(tmp=="t_fail_type:"){
			in >> fail_type;      
		}else if(tmp=="t_output_protect:"){
			in >> output_protect;
		}else if(tmp=="report_gap:"){
			in >> report_gap;
		}else if(tmp=="best_individual:"){
			in >> tmp;
			while (tmp != "}") {
				individual = individual + " " +tmp;
				in >> tmp;
			}
			individual = individual + " }";
		}else{
			//cerr << "Error while extracting: unknown value '" << tmp << "'!\n";
			in.ignore(10000, '\n');//ignore the rest of the line
		}
		in >> tmp;;
	}

}

void readFitness(char* file, float* fitnessMat){

	ifstream in(file);

	string tmp;
	in >> tmp;
	while(!in.eof()){
		if(tmp[0]=='#'){//a comment
			in.ignore(10000, '\n');//ignore the rest of the line
		}else if(tmp=="fitness:"){
			in >> fitnessMat[i];
			i++;
		}else if(tmp=="Best"){

		}else{
			//cerr << "Error while extracting: unknown value '" << tmp << "'!\n";
			in.ignore(10000, '\n');//ignore the rest of the line
		}
		in >> tmp;;
	}

}

int main(int argc, char* argv[])
{

	if((argc!=1)&&(argc<2)){
		cout << argc <<"\n";
		cout << "Usage 1: " << argv[0] << " [file_to_extract] [mode]\n";
		cout << "      2: " << "OR\n";
		cout << "      3: " << argv[0] << " [mode]\n\n";
		cout << "         " << "OR\n";
		cout << "         " << argv[0] << "\n\n";
		cout << "(mode)   " << " 0 extract all info(only usage 1) \n";
		cout << "         " << " 1 extract only individual(only usage 1)\n";
		cout << "         " << " 2 show datafields(default)\n\n";
                cout << "         " << " 3 show datafields generation|fitness\n\n";
		cout << "         " << " 4 extract all fitness values with generation, from the";
		cout <<		       " evolution(only usage 1)\n\n";
                cout << "         " << " 5 extract every 20eth fitness values with generation from the"; 
		cout <<		       " evolution(only usage 1)\n\n";
                cout << "         " << " 6 extract first 31 fitness values with generation from the";
		cout <<		       " evolution(only usage 1)\n\n";
		return 1;
	}//end if
	
	mode = 2;

	float fitnessMat[1000];

	if(argc>2){
		readFile(argv[1]);		// les inn fra fil (argv[1])
		mode = atoi(argv[2]);
		readFitness(argv[1], fitnessMat);
	}//end if

	if(argc == 2)
		mode = atoi(argv[1]);

	char buffer[250];

	/* Get the current working directory: */
	if( getcwd( buffer, 250) != NULL )
		batch = buffer;
		

	switch (mode) {
		case 1: cout << "\nindividual"<< individual << endl; break;

		case 2: cout << "type|noise|fail|error_tests|error_runs|totgen|fitness|reliability|";
			cout << "t_fitness|t_reliability|gate_count|used|batch|id|seed|individuals|";
			cout << "max_gen|algorithm|fitness_method|fail_type|output_protect|elitism|";
			cout << "group_size|mutationrate|crossoverrate|t_noise|t_fail|t_used|t_seed|";
			cout << "t_error_tests|t_error_runs|t_fitness_method|t_fail_type|";
			cout << "t_output_protect|individual\n"; break;
		
		case 3: cout << "generation\tfitness\n"; break;

		// Skriver ut alle aalepunktenn(1000 stk)
		case 4:	for(i=0;i<1000;i += 1)
				cout << (i*report_gap) << "\t" << fitnessMat[i] << endl;
			break;

		// Skriver ut hvert 20 aalepunkt(50 stk, hver 10000. generasjon
		case 5: for(i=0;i<1000;i += 20)
                                cout << (i*report_gap) << "\t" << fitnessMat[i] << endl;
                        break;

		// Skriver ut de orste 31 maalepunktene(tom gen 15000)
		case 6: for(i=0;i<31;i += 1)
                                cout << (i*report_gap) << "\t" << fitnessMat[i] << endl;
                        break;


		case 0:
		default: cout << type << "|" << noise << "|" << fail << "|" << error_tests << "|";
			 cout << error_runs << "|" << totgen << "|" << fitness << "|" << reliability;
			 cout << "|" << t_fitness << "|" << t_reliability << "|" << gate_count << "|";
			 cout << used << "|" << batch << "|" << id << "|" << seed << "|" << individuals;
			 cout << "|" << maxgen << "|" << algorithm << "|" << fitness_method << "|";
			 cout << fail_type << "|" << output_protect << "|" << elitism << "|" << groupsize;
			 cout << "|" << mutationrate << "|" << crossoverrate << "|" << t_noise << "|";
			 cout << t_fail << "|" << t_used << "|" << t_seed << "|" << t_error_tests << "|";
			 cout << t_error_runs << "|" << t_fitness_method << "|" << t_fail_type << "|";
			 cout << t_output_protect << "|" << individual << endl; break;
	}//end switch

	return 0;
}//end main
